/**********************************************************
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
***********************************************************/

#include <mega8.h> 
#define RS PORTC.4     //0- , 1- 
#define E PORTC.5      //    
#define LCD_PORT PORTC //  
#define time 80        //  

//------------  -----------------------
void delay(unsigned int a)
{unsigned int cnt;
 for (cnt=a; cnt>0; cnt--);
}    
//------------    -------------------
void lcd_com(unsigned char c)
{unsigned int cmd; 
 cmd=c;                      //      
 RS=0;                       //  
 E=1;                        //enable = 1
 LCD_PORT&=0xF0;             //   
 LCD_PORT=LCD_PORT|(cmd>>4); //  
 delay(time);                //
 E=0;                        // 
 delay(time);                //
 E=1;                        //enable = 1
 LCD_PORT&=0xF0;             //  
 LCD_PORT=LCD_PORT|(c&0x0F); //  
 delay(time);                //    
 E=0;                        //  
 delay(5*time);              //       
}
//-----------    ---------------------
void lcd_putchar(unsigned char d)
 {unsigned int dat;
  dat=d;                      //  
  RS=1;                       //  
  E=1;                        //enable = 1
  LCD_PORT&=0xF0;             //  
  LCD_PORT=LCD_PORT|(dat>>4); //  
  delay(time);                //
  E=0;                        //
  delay(time);                //
  E=1;                        //enable = 1
  LCD_PORT&=0xF0;             //  
  LCD_PORT=LCD_PORT|(d&0x0F); //  
  delay(time);                //    
  E=0;                        //
  delay(5*time);              //       
 }    
//-------------  ---------------------------
void lcd_clear(void)
{lcd_com(0x01); delay(time*1000);// 
}
//-----------  -----------------------
void lcd_init(void)
{delay(time*100);                // 
 lcd_com(0x33); delay(time*500); //
 lcd_com(0x32); lcd_com(0x28);   //4 , 2  (. Datasheet-s)
 lcd_com(0x08);                  // 
 lcd_clear();                    // 
 lcd_com(0x06);                  //  
 lcd_com(0x0C);                  //  
 delay(time*5);                  //       
}         
//----------    ---------------------
void lcd_puts(char *str)
{char i;
 while (i=*str++) lcd_putchar(i);
}
//--------      FLASH--------------
void lcd_putsf(char flash *str)
{char i;
while (i=*str++) lcd_putchar(i);
}
//--------     --------------
void lcd_gotoxy(unsigned char x, unsigned char y)
{
 lcd_com((0x80+y*64)+x); // .  080 - . . 
}
//------- ------------------------------------
void main(void)
{
//   C
// Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0x7F;

lcd_init();
lcd_gotoxy(1,0);
lcd_putsf("Hello, World!");
lcd_gotoxy(0,1);
lcd_putsf("www.roboforum.ru");
}
